G_BEGIN_DECLS

typedef void (*emp_cli_channel_handler_callback_for_handle_channel) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_handler_call_handle_channel (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    emp_cli_channel_handler_callback_for_handle_channel callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_handler_run_handle_channel (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_channel_interface_tube_signal_callback_tube_channel_state_changed) (TpProxy *proxy,
    guint arg_state,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_channel_interface_tube_connect_to_tube_channel_state_changed (TpProxy *proxy,
    emp_cli_channel_interface_tube_signal_callback_tube_channel_state_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_channel_type_dbus_tube_signal_callback_d_bus_names_changed) (TpProxy *proxy,
    GHashTable *arg_added,
    const GArray *arg_removed,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_channel_type_dbus_tube_connect_to_d_bus_names_changed (TpProxy *proxy,
    emp_cli_channel_type_dbus_tube_signal_callback_d_bus_names_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_channel_type_dbus_tube_callback_for_offer_d_bus_tube) (TpProxy *proxy,
    const gchar *out_address,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_type_dbus_tube_call_offer_d_bus_tube (TpProxy *proxy,
    gint timeout_ms,
    GHashTable *in_parameters,
    emp_cli_channel_type_dbus_tube_callback_for_offer_d_bus_tube callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_type_dbus_tube_run_offer_d_bus_tube (TpProxy *proxy,
    gint timeout_ms,
    GHashTable *in_parameters,
    gchar **out_address,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_channel_type_dbus_tube_callback_for_accept_d_bus_tube) (TpProxy *proxy,
    const gchar *out_address,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_type_dbus_tube_call_accept_d_bus_tube (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_channel_type_dbus_tube_callback_for_accept_d_bus_tube callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_type_dbus_tube_run_accept_d_bus_tube (TpProxy *proxy,
    gint timeout_ms,
    gchar **out_address,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_channel_type_stream_tube_signal_callback_stream_tube_new_connection) (TpProxy *proxy,
    guint arg_handle,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_channel_type_stream_tube_connect_to_stream_tube_new_connection (TpProxy *proxy,
    emp_cli_channel_type_stream_tube_signal_callback_stream_tube_new_connection callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_channel_type_stream_tube_callback_for_offer_stream_tube) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_type_stream_tube_call_offer_stream_tube (TpProxy *proxy,
    gint timeout_ms,
    guint in_address_type,
    const GValue *in_address,
    guint in_access_control,
    const GValue *in_access_control_param,
    GHashTable *in_parameters,
    emp_cli_channel_type_stream_tube_callback_for_offer_stream_tube callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_type_stream_tube_run_offer_stream_tube (TpProxy *proxy,
    gint timeout_ms,
    guint in_address_type,
    const GValue *in_address,
    guint in_access_control,
    const GValue *in_access_control_param,
    GHashTable *in_parameters,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_channel_type_stream_tube_callback_for_accept_stream_tube) (TpProxy *proxy,
    const GValue *out_address,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_type_stream_tube_call_accept_stream_tube (TpProxy *proxy,
    gint timeout_ms,
    guint in_address_type,
    guint in_access_control,
    const GValue *in_access_control_param,
    emp_cli_channel_type_stream_tube_callback_for_accept_stream_tube callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_type_stream_tube_run_accept_stream_tube (TpProxy *proxy,
    gint timeout_ms,
    guint in_address_type,
    guint in_access_control,
    const GValue *in_access_control_param,
    GValue **out_address,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_tube_handler_callback_for_handle_tube) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_tube_handler_call_handle_tube (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    emp_cli_tube_handler_callback_for_handle_tube callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_tube_handler_run_handle_tube (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
