#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * EmpSvcChannelHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelHandler EmpSvcChannelHandler;

/**
 * EmpSvcChannelHandlerClass:
 *
 * The class of EmpSvcChannelHandler.
 */
typedef struct _EmpSvcChannelHandlerClass EmpSvcChannelHandlerClass;

GType emp_svc_channel_handler_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_HANDLER \
  (emp_svc_channel_handler_get_type ())
#define EMP_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_HANDLER, EmpSvcChannelHandler))
#define EMP_IS_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_HANDLER))
#define EMP_SVC_CHANNEL_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_HANDLER, EmpSvcChannelHandlerClass))


typedef void (*emp_svc_channel_handler_handle_channel_impl) (EmpSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void emp_svc_channel_handler_implement_handle_channel (EmpSvcChannelHandlerClass *klass, emp_svc_channel_handler_handle_channel_impl impl);
/**
 * emp_svc_channel_handler_return_from_handle_channel:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context);
static inline void
emp_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


/**
 * EmpSvcChannelInterfaceTube:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelInterfaceTube EmpSvcChannelInterfaceTube;

/**
 * EmpSvcChannelInterfaceTubeClass:
 *
 * The class of EmpSvcChannelInterfaceTube.
 */
typedef struct _EmpSvcChannelInterfaceTubeClass EmpSvcChannelInterfaceTubeClass;

GType emp_svc_channel_interface_tube_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_INTERFACE_TUBE \
  (emp_svc_channel_interface_tube_get_type ())
#define EMP_SVC_CHANNEL_INTERFACE_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_TUBE, EmpSvcChannelInterfaceTube))
#define EMP_IS_SVC_CHANNEL_INTERFACE_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_TUBE))
#define EMP_SVC_CHANNEL_INTERFACE_TUBE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_TUBE, EmpSvcChannelInterfaceTubeClass))


void emp_svc_channel_interface_tube_emit_tube_channel_state_changed (gpointer instance,
    guint arg_state);

/**
 * EmpSvcChannelTypeDBusTube:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelTypeDBusTube EmpSvcChannelTypeDBusTube;

/**
 * EmpSvcChannelTypeDBusTubeClass:
 *
 * The class of EmpSvcChannelTypeDBusTube.
 */
typedef struct _EmpSvcChannelTypeDBusTubeClass EmpSvcChannelTypeDBusTubeClass;

GType emp_svc_channel_type_dbus_tube_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE \
  (emp_svc_channel_type_dbus_tube_get_type ())
#define EMP_SVC_CHANNEL_TYPE_DBUS_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE, EmpSvcChannelTypeDBusTube))
#define EMP_IS_SVC_CHANNEL_TYPE_DBUS_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE))
#define EMP_SVC_CHANNEL_TYPE_DBUS_TUBE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE, EmpSvcChannelTypeDBusTubeClass))


typedef void (*emp_svc_channel_type_dbus_tube_offer_d_bus_tube_impl) (EmpSvcChannelTypeDBusTube *self,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context);
void emp_svc_channel_type_dbus_tube_implement_offer_d_bus_tube (EmpSvcChannelTypeDBusTubeClass *klass, emp_svc_channel_type_dbus_tube_offer_d_bus_tube_impl impl);
/**
 * emp_svc_channel_type_dbus_tube_return_from_offer_d_bus_tube:
 * @context: The D-Bus method invocation context
 * @out_address: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_type_dbus_tube_return_from_offer_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address);
static inline void
emp_svc_channel_type_dbus_tube_return_from_offer_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address)
{
  dbus_g_method_return (context,
      out_address);
}

typedef void (*emp_svc_channel_type_dbus_tube_accept_d_bus_tube_impl) (EmpSvcChannelTypeDBusTube *self,
    DBusGMethodInvocation *context);
void emp_svc_channel_type_dbus_tube_implement_accept_d_bus_tube (EmpSvcChannelTypeDBusTubeClass *klass, emp_svc_channel_type_dbus_tube_accept_d_bus_tube_impl impl);
/**
 * emp_svc_channel_type_dbus_tube_return_from_accept_d_bus_tube:
 * @context: The D-Bus method invocation context
 * @out_address: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_type_dbus_tube_return_from_accept_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address);
static inline void
emp_svc_channel_type_dbus_tube_return_from_accept_d_bus_tube (DBusGMethodInvocation *context,
    const gchar *out_address)
{
  dbus_g_method_return (context,
      out_address);
}

void emp_svc_channel_type_dbus_tube_emit_d_bus_names_changed (gpointer instance,
    GHashTable *arg_added,
    const GArray *arg_removed);

/**
 * EmpSvcChannelTypeStreamTube:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelTypeStreamTube EmpSvcChannelTypeStreamTube;

/**
 * EmpSvcChannelTypeStreamTubeClass:
 *
 * The class of EmpSvcChannelTypeStreamTube.
 */
typedef struct _EmpSvcChannelTypeStreamTubeClass EmpSvcChannelTypeStreamTubeClass;

GType emp_svc_channel_type_stream_tube_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE \
  (emp_svc_channel_type_stream_tube_get_type ())
#define EMP_SVC_CHANNEL_TYPE_STREAM_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE, EmpSvcChannelTypeStreamTube))
#define EMP_IS_SVC_CHANNEL_TYPE_STREAM_TUBE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE))
#define EMP_SVC_CHANNEL_TYPE_STREAM_TUBE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE, EmpSvcChannelTypeStreamTubeClass))


typedef void (*emp_svc_channel_type_stream_tube_offer_stream_tube_impl) (EmpSvcChannelTypeStreamTube *self,
    guint in_address_type,
    const GValue *in_address,
    guint in_access_control,
    const GValue *in_access_control_param,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context);
void emp_svc_channel_type_stream_tube_implement_offer_stream_tube (EmpSvcChannelTypeStreamTubeClass *klass, emp_svc_channel_type_stream_tube_offer_stream_tube_impl impl);
/**
 * emp_svc_channel_type_stream_tube_return_from_offer_stream_tube:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_type_stream_tube_return_from_offer_stream_tube (DBusGMethodInvocation *context);
static inline void
emp_svc_channel_type_stream_tube_return_from_offer_stream_tube (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_channel_type_stream_tube_accept_stream_tube_impl) (EmpSvcChannelTypeStreamTube *self,
    guint in_address_type,
    guint in_access_control,
    const GValue *in_access_control_param,
    DBusGMethodInvocation *context);
void emp_svc_channel_type_stream_tube_implement_accept_stream_tube (EmpSvcChannelTypeStreamTubeClass *klass, emp_svc_channel_type_stream_tube_accept_stream_tube_impl impl);
/**
 * emp_svc_channel_type_stream_tube_return_from_accept_stream_tube:
 * @context: The D-Bus method invocation context
 * @out_address: const GValue * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_type_stream_tube_return_from_accept_stream_tube (DBusGMethodInvocation *context,
    const GValue *out_address);
static inline void
emp_svc_channel_type_stream_tube_return_from_accept_stream_tube (DBusGMethodInvocation *context,
    const GValue *out_address)
{
  dbus_g_method_return (context,
      out_address);
}

void emp_svc_channel_type_stream_tube_emit_stream_tube_new_connection (gpointer instance,
    guint arg_handle);

/**
 * EmpSvcTubeHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcTubeHandler EmpSvcTubeHandler;

/**
 * EmpSvcTubeHandlerClass:
 *
 * The class of EmpSvcTubeHandler.
 */
typedef struct _EmpSvcTubeHandlerClass EmpSvcTubeHandlerClass;

GType emp_svc_tube_handler_get_type (void);
#define EMP_TYPE_SVC_TUBE_HANDLER \
  (emp_svc_tube_handler_get_type ())
#define EMP_SVC_TUBE_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_TUBE_HANDLER, EmpSvcTubeHandler))
#define EMP_IS_SVC_TUBE_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_TUBE_HANDLER))
#define EMP_SVC_TUBE_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_TUBE_HANDLER, EmpSvcTubeHandlerClass))


typedef void (*emp_svc_tube_handler_handle_tube_impl) (EmpSvcTubeHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void emp_svc_tube_handler_implement_handle_tube (EmpSvcTubeHandlerClass *klass, emp_svc_tube_handler_handle_tube_impl impl);
/**
 * emp_svc_tube_handler_return_from_handle_tube:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_tube_handler_return_from_handle_tube (DBusGMethodInvocation *context);
static inline void
emp_svc_tube_handler_return_from_handle_tube (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}



G_END_DECLS
